namespace TestLibrary;

/// <summary>
///  
/// </summary>
public static class ArgumentHelper
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region NOT NULL  Ȯϱ - EnsureIsNotNull(argument, title)

    /// <summary>
    /// NOT NULL  Ȯϱ
    /// </summary>
    /// <param name="argument"></param>
    /// <param name="title"></param>
    public static void EnsureIsNotNull(object argument, string title)
    {
        if(argument == null)
        {
            throw new ArgumentNullException(title);
        }
    }

    #endregion
    #region NOT NULL̰   ڿ  Ȯϱ - EnsureIsNotNullAndNotEmpty(argument, title)

    /// <summary>
    /// NOT NULL̰   ڿ  Ȯϱ
    /// </summary>
    /// <param name="argument"></param>
    /// <param name="title"></param>
    public static void EnsureIsNotNullAndNotEmpty(string argument, string title)
    {
        if(argument == null)
        {
            throw new ArgumentNullException(title);
        }

        if(string.IsNullOrEmpty(argument))
        {
            throw new ArgumentException($"The {title} argument value must not be empty.");
        }
    }

    #endregion
    #region NOT NULL̰   ųʸ  Ȯϱ - EnsureIsNotNullAndNotEmpty<TKey, TValue>(argumentDictionary, title)

    /// <summary>
    /// NOT NULL̰   ųʸ  Ȯϱ
    /// </summary>
    /// <typeparam name="TKey">Ű Ÿ</typeparam>
    /// <typeparam name="TValue"> Ÿ</typeparam>
    /// <param name="argumentDictionary"> ųʸ</param>
    /// <param name="title"></param>
    public static void EnsureIsNotNullAndNotEmpty<TKey, TValue>(IDictionary<TKey, TValue> argumentDictionary, string title)
    {
        if(argumentDictionary == null || argumentDictionary.Count == 0)
        {
            throw new ArgumentNullException(title);
        }
    }

    #endregion
    #region NOT NULL   Ʈ  Ȯϱ - EnsureIsNotNullAndNotEmpty<T>(argumentList, title)

    /// <summary>
    /// NOT NULL   Ʈ  Ȯϱ
    /// </summary>
    /// <typeparam name="TItem">׸ Ÿ</typeparam>
    /// <param name="argumentList"> Ʈ</param>
    /// <param name="title"></param>
    public static void EnsureIsNotNullAndNotEmpty<TItem>(IList<TItem> argumentList, string title)
    {
        if(argumentList == null)
        {
            throw new ArgumentNullException(title);
        }

        if(argumentList.Count == 0)
        {
            throw new ArgumentException($"The {title} argument value must not be empty.");
        }
    }

    #endregion
}