namespace TestLibrary;

/// <summary>
///  
/// </summary>
public class LanguageRepository : ILanguageRepository
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    ///  ųʸ
    /// </summary>
    private readonly Dictionary<string, ILanguage> languageDictionary;

    /// <summary>
    /// б/  
    /// </summary>
    private readonly ReaderWriterLockSlim readerWriterLockSlim;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region  ̽   - LanguageEnumerable

    /// <summary>
    ///  ̽  
    /// </summary>
    public IEnumerable<ILanguage> LanguageEnumerable
    {
        get
        {
            return this.languageDictionary.Values;
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructir
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - LanguageRepository(languageDictionary)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="languageDictionary"> ųʸ</param>
    public LanguageRepository(Dictionary<string, ILanguage> languageDictionary)
    {
        this.languageDictionary   = languageDictionary;
        this.readerWriterLockSlim = new ReaderWriterLockSlim();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID ã - FindByID(languageID)

    /// <summary>
    /// ID ã
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns> ̽</returns>
    public ILanguage FindByID(string languageID)
    {
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(languageID, "languageID");
        
        ILanguage language = null;
        
        this.readerWriterLockSlim.EnterReadLock();

        try
        {
            language = this.languageDictionary.FirstOrDefault(x => (x.Key.ToLower() == languageID.ToLower()) || (x.Value.HasAlias(languageID))).Value;
        }
        finally
        {
            this.readerWriterLockSlim.ExitReadLock();
        }

        return language;
    }

    #endregion
    #region εϱ - Load(language)

    /// <summary>
    /// εϱ
    /// </summary>
    /// <param name="language"> ̽</param>
    public void Load(ILanguage language)
    {
        ArgumentHelper.EnsureIsNotNull(language, "language");

        if(string.IsNullOrEmpty(language.ID))
        {
            throw new ArgumentException("The language identifier must not be null or empty.", "language");
        }
        
        this.readerWriterLockSlim.EnterWriteLock();

        try
        {
            this.languageDictionary[language.ID] = language;
        }
        finally
        {
            this.readerWriterLockSlim.ExitWriteLock();
        }
    }

    #endregion
}