using System.Text.RegularExpressions;

namespace TestLibrary;

/// <summary>
/// ϵ 
/// </summary>
public class CompiledLanguage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// ID
    /// </summary>
    public string ID { get; set; }

    #endregion
    #region Ī - Name

    /// <summary>
    /// Ī
    /// </summary>
    public string Name { get; set; }

    #endregion
    #region Խ - Regex

    /// <summary>
    /// Խ
    /// </summary>
    public Regex Regex { get; set; }

    #endregion
    #region ĸó Ʈ - CaptureList

    /// <summary>
    /// ĸó Ʈ
    /// </summary>
    public IList<string> CaptureList { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - CompiledLanguage(id, name, regex, captureList)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="id">ID</param>
    /// <param name="name">Ī</param>
    /// <param name="regex">Խ</param>
    /// <param name="captureList">ĸó Ʈ</param>
    public CompiledLanguage(string id, string name, Regex regex, IList<string> captureList)
    {
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(id, "id");
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(name, "name");
        ArgumentHelper.EnsureIsNotNull(regex, "regex");
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(captureList, "captures");
        
        ID          = id;
        Name        = name;
        Regex       = regex;
        CaptureList = captureList;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ڿ ϱ - ToString()

    /// <summary>
    /// ڿ ϱ
    /// </summary>
    /// <returns>ڿ</returns>
    public override string ToString()
    {
        return Name;
    }

    #endregion
}