namespace TestLibrary;

/// <summary>
/// Ģ ĸó
/// </summary>
public static class RuleCapture
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region Field

    /// <summary>
    /// ڹ ũƮ ųʸ
    /// </summary>
    public static IDictionary<int, string> JavaScriptDictionary;

    /// <summary>
    /// C# ũƮ ųʸ
    /// </summary>
    public static IDictionary<int, string> CSharpScriptDictionary;

    /// <summary>
    /// VB.NET ũƮ ųʸ
    /// </summary>
    public static IDictionary<int, string> VbDotNetScriptDictionary;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Static

    #region  - RuleCapture()

    /// <summary>
    /// 
    /// </summary>
    static RuleCapture()
    {
        JavaScriptDictionary     = BuildCaptureDictionary(LanguageID.JAVASCRIPT);
        CSharpScriptDictionary   = BuildCaptureDictionary(LanguageID.CSHARP    );
        VbDotNetScriptDictionary = BuildCaptureDictionary(LanguageID.VBDOTNET  );
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region ĸó ųʸ  - BuildCaptureDictionary(languageID)

    /// <summary>
    /// ĸó ųʸ 
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns>ĸó ųʸ</returns>
    private static IDictionary<int, string> BuildCaptureDictionary(string languageID)
    {
        return new Dictionary<int, string>
        {
            {  1, ScopeName.HtmlTagDelimiter                },
            {  2, ScopeName.HtmlElementName                 },
            {  3, ScopeName.HtmlAttributeName               },
            {  4, ScopeName.HtmlOperator                    },
            {  5, ScopeName.HtmlAttributeValue              },
            {  6, ScopeName.HtmlAttributeName               },
            {  7, ScopeName.HtmlOperator                    },
            {  8, ScopeName.HtmlAttributeValue              },
            {  9, ScopeName.HtmlAttributeName               },
            { 10, ScopeName.HtmlOperator                    },
            { 11, ScopeName.HtmlAttributeValue              },
            { 12, ScopeName.HtmlAttributeName               },
            { 13, ScopeName.HtmlAttributeName               },
            { 14, ScopeName.HtmlOperator                    },
            { 15, ScopeName.HtmlAttributeValue              },
            { 16, ScopeName.HtmlAttributeName               },
            { 17, ScopeName.HtmlOperator                    },
            { 18, ScopeName.HtmlAttributeValue              },
            { 19, ScopeName.HtmlAttributeName               },
            { 20, ScopeName.HtmlOperator                    },
            { 21, ScopeName.HtmlAttributeValue              },
            { 22, ScopeName.HtmlAttributeName               },
            { 23, ScopeName.HtmlOperator                    },
            { 24, ScopeName.HtmlAttributeValue              },
            { 25, ScopeName.HtmlAttributeName               },
            { 26, ScopeName.HtmlTagDelimiter                },
            { 27, $"{ScopeName.LanguagePrefix}{languageID}" },
            { 28, ScopeName.HtmlTagDelimiter                },
            { 29, ScopeName.HtmlElementName                 },
            { 30, ScopeName.HtmlTagDelimiter                }
        };
    }

    #endregion
}