namespace TestLibrary;

/// <summary>
///  
/// </summary>
public static class LanguageHelper
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Internal

    #region Field

    /// <summary>
    ///  
    /// </summary>
    internal static readonly LanguageRepository LanguageRepository;

    /// <summary>
    ///  ųʸ
    /// </summary>
    internal static readonly Dictionary<string, ILanguage> LanguageDictionary;

    /// <summary>
    /// ϵ  ųʸ
    /// </summary>
    internal static Dictionary<string, CompiledLanguage> CompiledLanguageDictionary;

    /// <summary>
    ///  б/  
    /// </summary>
    internal static ReaderWriterLockSlim CompileReaderWriterLockSlim;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region ASHX - ASHX

    /// <summary>
    /// ASHX
    /// </summary>
    public static ILanguage ASHX
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.ASHX);
        }
    }

    #endregion
    #region ASAX - ASAX

    /// <summary>
    /// ASAX
    /// </summary>
    public static ILanguage ASAX
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.ASAX);
        }
    }

    #endregion
    #region ASPX - ASPX

    /// <summary>
    /// ASPX
    /// </summary>
    public static ILanguage ASPX
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.ASPX);
        }
    }

    #endregion
    #region ASPXCS - ASPXCS

    /// <summary>
    /// ASPXCS
    /// </summary>
    public static ILanguage ASPXCS
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.ASPXCS);
        }
    }

    #endregion
    #region ASPXVB - ASPXVB

    /// <summary>
    /// ASPXVB
    /// </summary>
    public static ILanguage ASPXVB
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.ASPXVB);
        }
    }

    #endregion
    #region CPP - CPP

    /// <summary>
    /// CPP
    /// </summary>
    public static ILanguage CPP
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.CPP);
        }
    }

    #endregion
    #region CSHARP - CSHARP

    /// <summary>
    /// CSHARP
    /// </summary>
    public static ILanguage CSHARP
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.CSHARP);
        }
    }

    #endregion
    #region CSS - CSS

    /// <summary>
    /// CSS
    /// </summary>
    public static ILanguage CSS
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.CSS);
        }
    }

    #endregion
    #region FORTRAN - FORTRAN

    /// <summary>
    /// FORTRAN
    /// </summary>
    public static ILanguage FORTRAN
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.FORTRAN);
        }
    }

    #endregion
    #region FSHARP - FSHARP

    /// <summary>
    /// FSHARP
    /// </summary>
    public static ILanguage FSHARP
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.FSHARP);
        }
    }

    #endregion
    #region HASKELL - HASKELL

    /// <summary>
    /// HASKELL
    /// </summary>
    public static ILanguage HASKELL
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.HASKELL);
        }
    }

    #endregion
    #region HTML - HTML

    /// <summary>
    /// HTML
    /// </summary>
    public static ILanguage HTML
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.HTML);
        }
    }

    #endregion
    #region JAVA - JAVA

    /// <summary>
    /// JAVA
    /// </summary>
    public static ILanguage JAVA
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.JAVA);
        }
    }

    #endregion
    #region JAVASCRIPT - JAVASCRIPT

    /// <summary>
    /// JAVASCRIPT
    /// </summary>
    public static ILanguage JAVASCRIPT
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.JAVASCRIPT);
        }
    }

    #endregion
    #region KOKA - KOKA

    /// <summary>
    /// KOKA
    /// </summary>
    public static ILanguage KOKA
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.KOKA);
        }
    }

    #endregion
    #region MARKDOWN - MARKDOWN

    /// <summary>
    /// MARKDOWN
    /// </summary>
    public static ILanguage MARKDOWN
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.MARKDOWN);
        }
    }

    #endregion
    #region MATLAB - MATLAB

    /// <summary>
    /// MATLAB
    /// </summary>
    public static ILanguage MATLAB
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.MATLAB);
        }
    }

    #endregion
    #region PHP - PHP

    /// <summary>
    /// PHP
    /// </summary>
    public static ILanguage PHP
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.PHP);
        }
    }

    #endregion
    #region POWERSHELL - POWERSHELL

    /// <summary>
    /// POWERSHELL
    /// </summary>
    public static ILanguage POWERSHELL
    {
        get { return LanguageRepository.FindByID(LanguageID.POWERSHELL); }
    }

    #endregion
    #region PYTHON - PYTHON

    /// <summary>
    /// PYTHON
    /// </summary>
    public static ILanguage PYTHON
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.PYTHON);
        }
    }

    #endregion
    #region SQL - SQL

    /// <summary>
    /// SQL
    /// </summary>
    public static ILanguage SQL
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.SQL);
        }
    }

    #endregion
    #region TYPESCRIPT - TYPESCRIPT

    /// <summary>
    /// TYPESCRIPT
    /// </summary>
    public static ILanguage TYPESCRIPT
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.TYPESCRIPT);
        }
    }

    #endregion
    #region VBDOTNET - VBDOTNET

    /// <summary>
    /// VBDOTNET
    /// </summary>
    public static ILanguage VBDOTNET
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.VBDOTNET);
        }
    }

    #endregion
    #region XML - XML

    /// <summary>
    /// XML
    /// </summary>
    public static ILanguage XML
    {
        get
        {
            return LanguageRepository.FindByID(LanguageID.XML);
        }
    }

    #endregion

    #region  ̽   - LanguageEnumerable

    /// <summary>
    ///  ̽  
    /// </summary>
    public static IEnumerable<ILanguage> LanguageEnumerable
    {
        get
        {
            return LanguageRepository.LanguageEnumerable;
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Static

    #region  - LanguageHelper()

    /// <summary>
    /// 
    /// </summary>
    static LanguageHelper()
    {
        LanguageDictionary          = new Dictionary<string, ILanguage>();
        CompiledLanguageDictionary  = new Dictionary<string, CompiledLanguage>();
        LanguageRepository          = new LanguageRepository(LanguageDictionary);
        CompileReaderWriterLockSlim = new ReaderWriterLockSlim();

        Load<JAVASCRIPT>();
        Load<HTML>();
        Load<CSHARP>();
        Load<VBDOTNET>();
        Load<ASHX>();
        Load<ASAX>();
        Load<ASPX>();
        Load<ASPXCS>();
        Load<ASPXVB>();
        Load<SQL>();
        Load<XML>();
        Load<PHP>();
        Load<CSS>();
        Load<CPP>();
        Load<JAVA>();
        Load<JSON>();
        Load<POWERSHELL>();
        Load<TYPESCRIPT>();
        Load<FSHARP>();
        Load<KOKA>();
        Load<HASKELL>();
        Load<MARKDOWN>();
        Load<FORTRAN>();
        Load<PYTHON>();
        Load<MATLAB>();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region ID ã - FindByID(languageID)

    /// <summary>
    /// ID ã
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns> ̽</returns>
    public static ILanguage FindByID(string languageID)
    {
        return LanguageRepository.FindByID(languageID);
    }

    #endregion
    #region εϱ - Load(language)

    /// <summary>
    /// εϱ
    /// </summary>
    /// <param name="language"></param>
    public static void Load(ILanguage language)
    {
        LanguageRepository.Load(language);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Private

    #region εϱ - Load<T>()

    /// <summary>
    /// εϱ
    /// </summary>
    /// <typeparam name="TLanguage"> Ÿ</typeparam>
    private static void Load<TLanguage>() where TLanguage : ILanguage, new()
    {
        Load(new TLanguage());
    }

    #endregion
}