namespace TestLibrary;

/// <summary>
/// ASHX
/// </summary>
public class ASHX : ILanguage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// ID
    /// </summary>
    public string ID
    {
        get
        {
            return LanguageID.ASHX;
        }
    }

    #endregion
    #region  - Name

    /// <summary>
    /// 
    /// </summary>
    public string Name
    {
        get
        {
            return "ASHX";
        }
    }

    #endregion
    #region CSS Ŭ - CSSClassName

    /// <summary>
    /// CSS Ŭ
    /// </summary>
    public string CSSClassName
    {
        get
        {
            return "ashx";
        }
    }

    #endregion
    #region ù   - FirstLinePattern

    /// <summary>
    /// ù  
    /// </summary>
    public string FirstLinePattern
    {
        get
        {
            return null;
        }
    }

    #endregion
    #region  Ģ Ʈ - LanguageRuleList

    /// <summary>
    ///  Ģ Ʈ
    /// </summary>
    public IList<LanguageRule> LanguageRuleList
    {
        get
        {
            return new List<LanguageRule>
            {
                new LanguageRule
                (
                    @"(<%)(--.*?--)(%>)",
                    new Dictionary<int, string>
                    {
                        { 1, ScopeName.HtmlServerSideScript },
                        { 2, ScopeName.HtmlComment          },
                        { 3, ScopeName.HtmlServerSideScript }
                    }
                ),
                new LanguageRule
                (
                    @"(?is)(?<=<%@.+?language=""c\#"".*?%>)(.*)",
                    new Dictionary<int, string>
                    {
                        { 1, string.Format("{0}{1}", ScopeName.LanguagePrefix, LanguageID.CSHARP) }
                    }
                ),
                new LanguageRule
                (
                    @"(?is)(?<=<%@.+?language=""vb"".*?%>)(.*)",
                    new Dictionary<int, string>
                    {
                        { 1, string.Format("{0}{1}", ScopeName.LanguagePrefix, LanguageID.VBDOTNET) }
                    }
                ),
                new LanguageRule
                (
                    @"(<%)(@)(?:\s+([a-zA-Z0-9]+))*(?:\s+([a-zA-Z0-9]+)(=)(""[^\n]*?""))*\s*?(%>)",
                    new Dictionary<int, string>
                    {
                        { 1, ScopeName.HtmlServerSideScript },
                        { 2, ScopeName.HtmlTagDelimiter     },
                        { 3, ScopeName.HtmlElementName      },
                        { 4, ScopeName.HtmlAttributeName    },
                        { 5, ScopeName.HtmlOperator         },
                        { 6, ScopeName.HtmlAttributeValue   },
                        { 7, ScopeName.HtmlServerSideScript }
                    }
                )
            };
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Ī  ϱ - HasAlias(languageID)

    /// <summary>
    /// Ī  ϱ
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns>Ī </returns>
    public bool HasAlias(string languageID)
    {
        return false;
    }

    #endregion
    #region ڿ ϱ - ToString()

    /// <summary>
    /// ڿ ϱ
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
        return Name;
    }

    #endregion
}