namespace TestLibrary;

/// <summary>
/// JSON
/// </summary>
public class JSON : ILanguage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// REGEX_STRING
    /// </summary>
    private const string REGEX_STRING = @"""[^""\\]*(?:\\[^\r\n]|[^""\\]*)*""";

    /// <summary>
    /// REGEX_NUMBER
    /// </summary>
    private const string REGEX_NUMBER = @"-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?";

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// 
    /// </summary>
    public string ID
    {
        get
        {
            return LanguageID.JSON;
        }
    }

    #endregion
    #region  - Name

    /// <summary>
    /// 
    /// </summary>
    public string Name
    {
        get
        {
            return "JSON";
        }
    }

    #endregion
    #region CSS Ŭ - CSSClassName

    /// <summary>
    /// CSS Ŭ
    /// </summary>
    public string CSSClassName
    {
        get
        {
            return "json";
        }
    }

    #endregion
    #region ù   - FirstLinePattern

    /// <summary>
    /// ù  
    /// </summary>
    public string FirstLinePattern
    {
        get
        {
            return null;
        }
    }

    #endregion
    #region  Ģ Ʈ - LanguageRuleList

    /// <summary>
    ///  Ģ Ʈ
    /// </summary>
    public IList<LanguageRule> LanguageRuleList
    {
        get
        {
            return new List<LanguageRule>
            {
                new LanguageRule
                (
                    $@"[,\{{]\s*({REGEX_STRING})\s*:",
                    new Dictionary<int, string>
                    {
                        {1, ScopeName.JsonKey }
                    }
                ),
                new LanguageRule
                (
                    REGEX_STRING,
                    new Dictionary<int, string>
                    {
                        {0, ScopeName.JsonString }
                    }
                ),
                new LanguageRule
                (
                    REGEX_NUMBER,
                    new Dictionary<int, string>
                    {
                        {0, ScopeName.JsonNumber }
                    }
                ),
                new LanguageRule
                (
                    @"\b(true|false|null)\b",
                    new Dictionary<int, string>
                    {
                        {1, ScopeName.JsonConst }
                    }
                )
            };
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Ī  ϱ - HasAlias(languageID)

    /// <summary>
    /// Ī  ϱ
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns>Ī </returns>
    public bool HasAlias(string languageID)
    {
        return false;
    }

    #endregion
    #region ڿ ϱ - ToString()

    /// <summary>
    /// ڿ ϱ
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
        return Name;
    }

    #endregion
}