namespace TestLibrary;

/// <summary>
/// Ŀ
/// </summary>
public class POWERSHELL : ILanguage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ID - ID

    /// <summary>
    /// ID
    /// </summary>
    public string ID
    {
        get
        {
            return LanguageID.POWERSHELL;
        }
    }

    #endregion
    #region  - Name

    /// <summary>
    /// 
    /// </summary>
    public string Name
    {
        get
        {
            return "PowerShell";
        }
    }

    #endregion
    #region CSS Ŭ - CSSClassName

    /// <summary>
    /// CSS Ŭ
    /// </summary>
    public string CSSClassName
    {
        get
        {
            return "powershell";
        }
    }

    #endregion
    #region ù°   - FirstLinePattern

    /// <summary>
    /// ù°  
    /// </summary>
    public string FirstLinePattern
    {
        get
        {
            return null;
        }
    }

    #endregion
    #region  Ģ Ʈ - LanguageRuleList

    /// <summary>
    ///  Ģ Ʈ
    /// </summary>
    public IList<LanguageRule> LanguageRuleList
    {
        get
        {
            return new List<LanguageRule>
            {
                new LanguageRule(
                    @"(?s)(<\#.*?\#>)",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.Comment}
                        }),
                new LanguageRule(
                    @"(\#.*?)\r?$",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.Comment}
                        }),
                new LanguageRule(
                    @"'[^\n]*?(?<!\\)'",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.String}
                        }),
                new LanguageRule(
                    @"(?s)@"".*?""@",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.StringCSharpVerbatim}
                        }),
                new LanguageRule(
                    @"(?s)(""[^\n]*?(?<!`)"")",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.String}
                        }),
                new LanguageRule(
                    @"\$(?:[\d\w\-]+(?::[\d\w\-]+)?|\$|\?|\^)",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellVariable}
                        }),
                new LanguageRule(
                    @"\${[^}]+}",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellVariable}
                        }),
                new LanguageRule(
                    @"(?i)\b(begin|break|catch|continue|data|do|dynamicparam|elseif|else|end|exit|filter|finally|foreach|for|from|function|if|in|param|process|return|switch|throw|trap|try|until|while)\b",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.Keyword}
                        }),
                new LanguageRule(
                    @"\b(\w+\-\w+)\b",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.PowerShellCommand}
                        }),
                new LanguageRule(
                    @"-(?:c|i)?(?:eq|ne|gt|ge|lt|le|notlike|like|notmatch|match|notcontains|contains|replace)",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellOperator}
                        }
                    ),
                new LanguageRule(
                    @"-(?:band|and|as|join|not|bxor|xor|bor|or|isnot|is|split)",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellOperator}
                        }
                    ),
                new LanguageRule(
                    @"-\w+\d*\w*",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellParameter}
                        }
                    ),
                new LanguageRule(
                    @"(?:\+=|-=|\*=|/=|%=|=|\+\+|--|\+|-|\*|/|%|\||,)",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellOperator}
                        }
                    ),
                new LanguageRule(
                    @"(?:\>\>|2\>&1|\>|2\>\>|2\>)",
                    new Dictionary<int, string>
                        {
                            {0, ScopeName.PowerShellOperator}
                        }
                    ),
                new LanguageRule(
                    @"(?is)\[(cmdletbinding|alias|outputtype|parameter|validatenotnull|validatenotnullorempty|validatecount|validateset|allownull|allowemptycollection|allowemptystring|validatescript|validaterange|validatepattern|validatelength|supportswildcards)[^\]]+\]",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.PowerShellAttribute}
                        }),
                new LanguageRule(
                    @"(\[)([^\]]+)(\])(::)?",
                    new Dictionary<int, string>
                        {
                            {1, ScopeName.PowerShellOperator},
                            {2, ScopeName.PowerShellType},
                            {3, ScopeName.PowerShellOperator},
                            {4, ScopeName.PowerShellOperator}
                        })
            };
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Ī  ϱ - HasAlias(languageID)

    /// <summary>
    /// Ī  ϱ
    /// </summary>
    /// <param name="languageID"> ID</param>
    /// <returns>Ī </returns>
    public bool HasAlias(string languageID)
    {
        switch (languageID.ToLower())
        {
            case "posh":
            case "ps1":
            case "pwsh":

                return true;

            default:

                return false;
        }
    }

    #endregion
    #region ڿ ϱ - ToString()

    /// <summary>
    /// ڿ ϱ
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
        return Name;
    }

    #endregion
}