using System;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

using TestLibrary;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        Loaded += Page_Loaded;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region  ε óϱ - Page_Loaded(sender, e)

    /// <summary>
    ///  ε óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ Ӥ</param>
    private async void Page_Loaded(object sender, RoutedEventArgs e)
    {
        string sourceCode = @"using Microsoft.UI.Text;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Documents;

using ColorCode;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            var paragraph = new Paragraph();
            var csharpstring = ""public void Method()\n{\n}"";
            var formatter = new RichTextBlockFormatter();
            formatter.FormatInlines(csharpstring, Languages.CSharp, paragraph.Inlines);

            this.richTextBlock.Blocks.Add(paragraph);
        }

        #endregion
    }
}";

        HTMLClassFormatter htmlClassFormatter = new HTMLClassFormatter();

        string body = htmlClassFormatter.GetHTMLString(sourceCode, LanguageHelper.CSHARP);
        string css  = htmlClassFormatter.GetCSSString();
        string html = @$"<html>
<style>
{css}
</style>
<body>
{body}
</body>
</html>
";

        await this.webView2.EnsureCoreWebView2Async();

        this.webView2.NavigateToString(html);
    }

    #endregion
}